<script>
  import { json } from "d3-fetch";
  import { onMount } from "svelte";
  import { max, min } from "d3-array";
  import Lineplots from "./_design_1_lineplots.svelte";
  import ControlsLocation from "./_design_1_controls_location.svelte";
  import ControlsScaling from "./_design_1_controls_scaling.svelte";

  // Load the data
  let data = null;
  onMount(async () => {
    data = await json("/data/hourly_heating_december.json");
  });
  
  let checked_location = "Baltimore";
  let checked_scaling = "within_building_type";

  function extract_data(data, checked_location){
    return data.filter(datum => datum.city == checked_location);
  }

  function get_min(data, checked_location, type){
    let min_;
    if (type == "across_all_locations"){
      min_ = min(data, function(d) { return d.total_heating_energy; });
    } else if (type == "within_building_type"){
      let data_ = extract_data(data, checked_location);
      console.log(data_.length);
      min_ = min(extract_data(data, checked_location), function(d) { return d.total_heating_energy; });
    } else{
      console.log("No such scaling type!");
    }
    return min_;
  }

  function get_max(data, checked_location, type){
    let max_;
    if (type == "across_all_locations"){
      max_ = max(data, function(d) { return d.total_heating_energy; });
    } else if (type == "within_building_type"){
      max_ = max(extract_data(data, checked_location), function(d) { return d.total_heating_energy; });
    } else{
      console.log("No such scaling type!");
    }
    return max_;
  }
</script>



{#if !data}
  <p>Loading the data, please wait...</p>
{:else}
  <div>
    <Lineplots data={extract_data(data, checked_location)} checked_scaling={checked_scaling}/>
    <div class="row">
      <ControlsLocation bind:checked_location={checked_location}/>
      <ControlsScaling bind:checked_scaling={checked_scaling}/>
    </div>
    <p id="design_1_title">Energy use over multiple days</p>
  </div>
{/if} 


<style>
  #design_1_title {
    font-size: 20px;
    text-align:center;
  }
</style>